//	AddNoise.cpp
//	----------------------------------------------------------------------------
//	File generated automatically by Niall's AVLib Resource Generator.
//	----------------------------------------------------------------------------

#include "AddNoise.h"
#include "UTF8File.h"

//------------------------------------------------------------------------------
AddNoise::AddNoise():
Shader(std::wstring(vertexString), std::wstring(fragmentString), L"AddNoise")
{

}

//------------------------------------------------------------------------------
const wchar_t AddNoise::vertexString[] = {L"\
	#version 120\n\
	\n\
	attribute vec4 avlVertexPosition;\n\
	attribute vec4 avlVertexColour;\n\
	\n\
	uniform mat4x4 avlProjectionMatrix;\n\
	uniform mat4x4 avlModelviewMatrix;\n\
	\n\
	attribute vec2 avlBaseTexCoords;\n\
	\n\
	varying vec2 avlFragBaseTexCoords;\n\
	varying vec4 avlFragVertexColour;\n\
	\n\
	void main()\n\
	{\n\
		avlFragBaseTexCoords = avlBaseTexCoords;\n\
		avlFragVertexColour = avlVertexColour;\n\
		gl_Position = avlModelviewMatrix * avlVertexPosition * avlProjectionMatrix;\n\
	}\n\
"};
const wchar_t AddNoise::fragmentString[] = {L"\
	#version 120\n\
	\n\
	uniform vec4 avlColour;\n\
	\n\
	uniform sampler2D avlBaseTexture;\n\
	\n\
	uniform float avlTextureExists;\n\
	uniform float avlUseVertexColour;\n\
	\n\
	uniform float noiseSeedInc;\n\
	uniform float brightness;\n\
	uniform float saturation;\n\
	uniform float contrast;\n\
	\n\
	varying vec2 avlFragBaseTexCoords;\n\
	varying vec4 avlFragVertexColour;\n\
	\n\
	/*\n\
	** Contrast, saturation, brightness\n\
	** Code of this function is from TGM's shader pack\n\
	** http://irrlicht.sourceforge.net/phpBB2/viewtopic.php?t=21057\n\
	*/\n\
	\n\
	// For all settings: 1.0 = 100% 0.5=50% 1.5 = 150%\n\
	vec3 ContrastSaturationBrightness(vec3 color, float brt, float sat, float con)\n\
	{\n\
		// Increase or decrease theese values to adjust r, g and b color channels seperately\n\
		const float AvgLumR = 0.5;\n\
		const float AvgLumG = 0.5;\n\
		const float AvgLumB = 0.5;\n\
		\n\
		const vec3 LumCoeff = vec3(0.2125, 0.7154, 0.0721);\n\
		\n\
		vec3 AvgLumin = vec3(AvgLumR, AvgLumG, AvgLumB);\n\
		vec3 brtColor = color * brt;\n\
		vec3 intensity = vec3(dot(brtColor, LumCoeff));\n\
		vec3 satColor = mix(intensity, brtColor, sat);\n\
		vec3 conColor = mix(AvgLumin, satColor, con);\n\
		return conColor;\n\
	}\n\
	\n\
	float rand(vec2 co)\n\
	{\n\
		return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);\n\
	}\n\
	\n\
	void main()\n\
	{\n\
		vec4 b = texture2D(avlBaseTexture, avlFragBaseTexCoords);\n\
		vec4 col = mix(avlColour, avlFragVertexColour, avlUseVertexColour);\n\
		float dist = distance(vec2(0.5, 0.5), avlFragBaseTexCoords*1.0);\n\
		vec4 c = mix(col, col * b * ((rand(avlFragBaseTexCoords+noiseSeedInc)*0.1f)+0.9f), avlTextureExists);\n\
		\n\
		//gl_FragColor = mix(vec4(redFlash, 0.0, 0.0, 1.0), c, (1.0 - (dist * dist)));\n\
		//c.rgb = ContrastSaturationBrightness(c.rgb, 1.0, 1.0+(7.0*redFlash), 1.0+(3.0*redFlash));\n\
		c.rgb = ContrastSaturationBrightness(c.rgb, 1.0+(2.0*brightness), 1.0+(7.0*saturation), 1.0+(3.0*contrast));\n\
		c = mix(vec4(brightness, 0.0, 0.0, 1.0), c, (1.0 - (dist * dist)));\n\
	\n\
		gl_FragColor = c;\n\
	}\n\
"};
